//============================================================================
// Name        : Decompositions.hpp
// Author      : Zdeněk Kalčík
// Copyright   : @2009@
// Project 		 : BDS
//============================================================================

#ifndef DECOMPOSITIONS_HPP_
#define DECOMPOSITIONS_HPP_

#include <iostream>
#include <sstream>
#include <fstream>
#include <vector>
#include <stdlib.h>
#include <string.h>
#include <map>
#include <set>

using namespace std;

#include "cudd.h"
#include "FileUtil.hpp"
#include "Decomp.hpp"

typedef struct functions {
	DdNode *originalFunction;
	DdNode *newFunction;
} functions;

void initCut(set<int> cut2);
void initGNX(DdNode *node);
void initReorderType(char type);

void doAND(Decomp *decomp);

void doOR(Decomp *decomp);

void doXNOR(Decomp *decomp);

DdNode * copyFunction(DdNode *node, DdManager *managerNew, bool first);
vector<Decomp*> copyFunctions(vector<DdNode*> functions, DdManager *managerOld);

string getNodeIndex(DdNode *node);

void reorder(DdManager* manager, char reorderAlg);

void clearCut();
void addToCut(int index);
functions newAND(DdManager *originalManager, DdNode *originalFunction, DdManager *newManager);
functions newOR(DdManager *originalManager, DdNode *originalFunction, DdManager *newManager);
functions newXNOR(DdManager *originalManager, DdNode *originalFunction, DdManager *newManager);

#endif /* DECOMPOSITIONS_HPP_ */
