//============================================================================
// Name        : FileUtil.hpp
// Author      : Zdeněk Kalčík
// Copyright   : @2009@
// Project 		 : BDS
//============================================================================

#ifndef FILEUTIL_HPP_
#define FILEUTIL_HPP_

#include <iostream>
#include <sstream>
#include <fstream>
#include <vector>
#include <stdlib.h>
#include <string.h>
#include <map>
#include <set>

using namespace std;

#include "cudd.h"
#include "Entry.hpp"
#include "Decomp.hpp"

#define MANAG_CACHE_SIZE 700 //in kb

//structure for BDD
typedef struct fileStructureNew {
	vector<string> inputNames;
	vector<string> outputNames;
	string model;
	string con0, con1;
	vector<Entry*> orderedEntries1;
	vector<DdNode*> outputFunctions;
	map<string, int> variableCount;
} fileStructureNew;

void init(DdManager* manager);

void printStatistics(DdManager *manag);

fileStructureNew readStoreFile(char* fileName);

fileStructureNew buildBDD(fileStructureNew structure);

void writeDot(DdManager* manager, fileStructureNew structure, char* fileName);

void writeDotForDecomp(Decomp *decomp, char* fileName);

void writeBliff(DdManager* manager, fileStructureNew structure, char* fileName);
void writeBliffOld(DdManager* manager, fileStructureNew structure, char* fileName);

void writeDecomp(vector<Decomp*> decomps, char* fileName, fileStructureNew structure);

void writeHead(fileStructureNew structure, FILE *file);
void writeHeadNew(fileStructureNew structure, FILE *file);
void proceedDecomp(Decomp *decomp, FILE *file, string funcName);
void writeEnd(fileStructureNew structure, char* fileName, FILE *file);

#endif /* FILEUTIL_HPP_ */
